#include "PreferencesDialog.h"
#include <string>
#include <ApplicationServices/ApplicationServices.h>

using namespace std;

namespace Harbinger {

    PreferencesDialog::PreferencesDialog(QWidget* parent)
        : QDialog(parent)
    {
        this->setupUi(this);
    }

    PreferencesDialog::~PreferencesDialog()
    {
        /* empty */
    }

    Preferences
    PreferencesDialog::preferences() const
    {
        Preferences rv;
        /* Copy the values from the widges used to edit them so they
         * can be returned to the user. */
        rv.advanceNotice =
            this->getLineEdit<unsigned long>(this->advanceNoticeLineEdit);
        rv.screensaver =
            this->getLineEdit<unsigned long>(this->screensaverLineEdit);
        rv.message = qPrintable(this->messageLineEdit->text());
        return rv;
    }

    void
    PreferencesDialog::setPreferences(const Preferences& preferences)
    {
        /* Copy the values from the "Preferences" object supplied by
         * the user into the widgets used to edit those values. */
        this->setLineEdit(this->advanceNoticeLineEdit,
                          preferences.advanceNotice);
        this->setLineEdit(this->screensaverLineEdit,
                          preferences.screensaver);
        this->messageLineEdit->setText(
            QString::fromLatin1(preferences.message.c_str()));
    }

}
